Index: /LMDZ6/trunk/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 3434)
+++ /LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 3435)
@@ -4492,5 +4565,5 @@
   IF (ok_airs) then
 
-  IF (itap.eq.1.or.MOD(itap,NINT(freq_airs/dtime)).EQ.0) THEN
+  IF (itap.eq.1.or.MOD(itap,NINT(freq_airs/phys_tstep)).EQ.0) THEN
      write(*,*) 'je vais appeler simu_airs, ok_airs, freq_airs=', ok_airs, freq_airs
      CALL simu_airs(itap,rneb, t_seri, cldemi, fiwc, ref_ice, pphi, pplay, paprs,&
@@ -4547,5 +4620,5 @@
     CALL phytrac ( &
          itap,     days_elapsed+1,    jH_cur,   debut, &
-         lafin,    dtime,     u, v,     t, &
+         lafin,    phys_tstep,     u, v,     t, &
          paprs,    pplay,     pmfu,     pmfd, &
          pen_u,    pde_u,     pen_d,    pde_d, &
@@ -4582,5 +4655,5 @@
             cdragh,coefh(1:klon,1:klev,is_ave),u1,v1,ftsol,pctsrf, &
             frac_impa, frac_nucl, &
-            pphis,cell_area,dtime,itap, &
+            pphis,cell_area,phys_tstep,itap, &
             qx(:,:,ivap),da,phi,mp,upwd,dnwd)
 
@@ -4653,5 +4726,5 @@
 
        CALL chemhook_end ( &
-            dtime, &
+            phys_tstep, &
             pplay, &
             t_seri, &
@@ -4688,12 +4761,12 @@
     DO k = 1, klev
        DO i = 1, klon
-          d_u(i,k) = ( u_seri(i,k) - u(i,k) ) / dtime
-          d_v(i,k) = ( v_seri(i,k) - v(i,k) ) / dtime
-          d_t(i,k) = ( t_seri(i,k)-t(i,k) ) / dtime
-          d_qx(i,k,ivap) = ( q_seri(i,k) - qx(i,k,ivap) ) / dtime
-          d_qx(i,k,iliq) = ( ql_seri(i,k) - qx(i,k,iliq) ) / dtime
+          d_u(i,k) = ( u_seri(i,k) - u(i,k) ) / phys_tstep
+          d_v(i,k) = ( v_seri(i,k) - v(i,k) ) / phys_tstep
+          d_t(i,k) = ( t_seri(i,k)-t(i,k) ) / phys_tstep
+          d_qx(i,k,ivap) = ( q_seri(i,k) - qx(i,k,ivap) ) / phys_tstep
+          d_qx(i,k,iliq) = ( ql_seri(i,k) - qx(i,k,iliq) ) / phys_tstep
           !CR: on ajoute le contenu en glace
           IF (nqo.eq.3) THEN
-             d_qx(i,k,isol) = ( qs_seri(i,k) - qx(i,k,isol) ) / dtime
+             d_qx(i,k,isol) = ( qs_seri(i,k) - qx(i,k,isol) ) / phys_tstep
           ENDIF
        ENDDO
@@ -4707,6 +4780,6 @@
           DO  k = 1, klev
              DO  i = 1, klon
-                ! d_qx(i,k,iq) = ( tr_seri(i,k,iq-2) - qx(i,k,iq) ) / dtime
-                d_qx(i,k,iq) = ( tr_seri(i,k,iq-nqo) - qx(i,k,iq) ) / dtime
+                ! d_qx(i,k,iq) = ( tr_seri(i,k,iq-2) - qx(i,k,iq) ) / phys_tstep
+                d_qx(i,k,iq) = ( tr_seri(i,k,iq-nqo) - qx(i,k,iq) ) / phys_tstep
              ENDDO
           ENDDO
@@ -4962,13 +5035,17 @@
        !         write(97) u_seri,v_seri,t_seri,q_seri
        !         close(97)
-       !$OMP MASTER
-       IF (read_climoz >= 1) THEN
-          IF (is_mpi_root) THEN
-             CALL nf95_close(ncid_climoz)
-          ENDIF
-          DEALLOCATE(press_edg_climoz) ! pointer
-          DEALLOCATE(press_cen_climoz) ! pointer
-       ENDIF
-       !$OMP END MASTER
+      
+       IF (is_omp_master) THEN
+       
+         IF (read_climoz >= 1) THEN
+           IF (is_mpi_root) CALL nf95_close(ncid_climoz)
+            DEALLOCATE(press_edg_climoz) ! pointer
+            DEALLOCATE(press_cen_climoz) ! pointer
+         ENDIF
+       
+       ENDIF
+#ifdef CPP_XIOS
+       IF (is_omp_master) CALL xios_context_finalize
+#endif
        print *,' physiq fin, nombre de steps ou cvpas = 1 : ', Ncvpaseq1
     ENDIF
Index: /LMDZ6/trunk/libf/phylmd/radlwsw_m.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/radlwsw_m.F90	(revision 3434)
+++ /LMDZ6/trunk/libf/phylmd/radlwsw_m.F90	(revision 3435)
@@ -398,4 +398,9 @@
   cgaero(:,:,:,:)=0.
   lldebug=.FALSE.
+
+  ztopsw_aero(:,:)  = 0. !ym missing init : warning : not initialized in SW_AEROAR4
+  ztopsw0_aero(:,:) = 0. !ym missing init : warning : not initialized in SW_AEROAR4
+  zsolsw_aero(:,:)  = 0. !ym missing init : warning : not initialized in SW_AEROAR4
+  zsolsw0_aero(:,:) = 0. !ym missing init : warning : not initialized in SW_AEROAR4
   
   !
Index: /LMDZ6/trunk/libf/phylmd/readaerosol.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/readaerosol.F90	(revision 3434)
+++ /LMDZ6/trunk/libf/phylmd/readaerosol.F90	(revision 3435)
@@ -4,4 +4,11 @@
 
   REAL, SAVE :: not_valid=-333.
+  
+  INTEGER, SAVE :: nbp_lon_src
+!$OMP THREADPRIVATE(nbp_lon_src)  
+  INTEGER, SAVE :: nbp_lat_src
+!$OMP THREADPRIVATE(nbp_lat_src)  
+  REAL, ALLOCATABLE, SAVE    :: psurf_interp(:,:)
+!$OMP THREADPRIVATE(psurf_interp)  
 
 CONTAINS
@@ -167,4 +174,74 @@
 
 
+  SUBROUTINE init_aero_fromfile(flag_aerosol)
+  USE netcdf
+  USE mod_phys_lmdz_para
+  USE mod_grid_phy_lmdz, ONLY: grid_type, unstructured
+  USE xios
+  IMPLICIT NONE
+  INTEGER, INTENT(IN) :: flag_aerosol
+  REAL,ALLOCATABLE :: lat_src(:)
+  REAL,ALLOCATABLE :: lon_src(:)
+  CHARACTER(LEN=*),PARAMETER :: file_aerosol='aerosols.nat.nc'
+  CHARACTER(LEN=*),PARAMETER :: file_so4='so4.nat.nc'
+  INTEGER :: klev_src
+  INTEGER :: ierr ,ncid, dimID, varid
+  REAL :: null_array(0)
+
+  IF (flag_aerosol>0 .AND. grid_type==unstructured) THEN
+  
+    IF (is_omp_root) THEN
+  
+      IF (is_mpi_root) THEN
+    
+        IF (nf90_open(TRIM(file_aerosol), NF90_NOWRITE, ncid) /= NF90_NOERR) THEN
+          CALL check_err( nf90_open(TRIM(file_so4), NF90_NOWRITE, ncid), "pb open "//trim(file_so4) )
+        ENDIF
+
+        ! Read and test longitudes
+        CALL check_err( nf90_inq_dimid(ncid, "lon", dimID),"pb inq dim lon") 
+        CALL check_err( nf90_inquire_dimension(ncid, dimID, len = nbp_lon_src),"pb inq dim lon")
+        CALL check_err( nf90_inq_varid(ncid, 'lon', varid),"pb inq lon" )
+        ALLOCATE(lon_src(nbp_lon_src))
+        CALL check_err( nf90_get_var(ncid, varid, lon_src(:)),"pb get lon" )
+
+        ! Read and test latitudes
+        CALL check_err( nf90_inq_dimid(ncid, "lat", dimID),"pb inq dim lat") 
+        CALL check_err( nf90_inquire_dimension(ncid, dimID, len = nbp_lat_src),"pb inq dim lat")
+        CALL check_err( nf90_inq_varid(ncid, 'lat', varid),"pb inq lat" )
+        ALLOCATE(lat_src(nbp_lat_src))
+        CALL check_err( nf90_get_var(ncid, varid, lat_src(:)),"pb get lat" )
+        IF (nf90_inq_dimid(ncid, 'lev', dimid) /= NF90_NOERR) THEN
+          IF (nf90_inq_dimid(ncid, 'presnivs', dimid)/= NF90_NOERR) THEN
+             CALL check_err(nf90_inq_dimid(ncid, 'PRESNIVS', dimid),'dimension lev,PRESNIVS or presnivs not in file')
+          ENDIF
+        ENDIF
+        CALL check_err( nf90_inquire_dimension(ncid, dimid, len = klev_src),"pb inq dim for PRESNIVS or lev" )
+        CALL check_err( nf90_close(ncid),"pb in close" )   
+      ENDIF
+
+      CALL bcast_mpi(nbp_lat_src)
+      CALL bcast_mpi(nbp_lon_src)
+      CALL bcast_mpi(klev_src)
+
+      IF (is_mpi_root ) THEN
+        CALL xios_set_domain_attr("domain_aerosol",nj_glo=nbp_lat_src, nj=nbp_lat_src, jbegin=0, latvalue_1d=lat_src)
+        CALL xios_set_domain_attr("domain_aerosol",ni_glo=nbp_lon_src, ni=nbp_lon_src, ibegin=0, lonvalue_1d=lon_src)
+      ELSE
+        CALL xios_set_domain_attr("domain_aerosol",nj_glo=nbp_lat_src, nj=0, jbegin=0, latvalue_1d=null_array )
+        CALL xios_set_domain_attr("domain_aerosol",ni_glo=nbp_lon_src, ni=0, ibegin=0, lonvalue_1d=null_array)
+      ENDIF
+      CALL xios_set_axis_attr("axis_aerosol",n_glo=klev_src)
+      CALL xios_set_fieldgroup_attr("aerosols", enabled=.TRUE.)
+  
+    ENDIF
+    
+  ENDIF    
+ 
+  END SUBROUTINE init_aero_fromfile
+
+
+    
+
   SUBROUTINE get_aero_fromfile(varname, cyr, filename, klev_src, pt_ap, pt_b, pt_year, psurf_out, load_out)
 !****************************************************************************************
@@ -187,9 +264,10 @@
     USE netcdf
     USE dimphy
-    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, klon_glo, &
-                                 grid2Dto1D_glo
+    USE mod_grid_phy_lmdz, ONLY: nbp_lon_=>nbp_lon, nbp_lat_=>nbp_lat, klon_glo, &
+                                 grid2Dto1D_glo, grid_type, unstructured
     USE mod_phys_lmdz_para
     USE iophy, ONLY : io_lon, io_lat
     USE print_control_mod, ONLY: lunout
+    USE xios
 
     IMPLICIT NONE
@@ -205,6 +283,9 @@
     REAL, POINTER, DIMENSION(:)           :: pt_b         ! Pointer for describing the vertical levels      
     REAL, POINTER, DIMENSION(:,:,:)       :: pt_year      ! Pointer-variabale from file, 12 month, grid : klon,klev_src
+    REAL, POINTER, DIMENSION(:,:,:)       :: pt_year_mpi  ! Pointer-variabale from file, 12 month, grid : klon,klev_src
     REAL, DIMENSION(klon,12), INTENT(OUT) :: psurf_out    ! Surface pression for 12 months
+    REAL, DIMENSION(klon_mpi,12)          :: psurf_out_mpi    ! Surface pression for 12 months
     REAL, DIMENSION(klon,12), INTENT(OUT) :: load_out     ! Aerosol mass load in each column
+    REAL, DIMENSION(klon_mpi,12)          :: load_out_mpi     ! Aerosol mass load in each column
     INTEGER                               :: nbr_tsteps   ! number of month in file read
 
@@ -220,15 +301,39 @@
     REAL, ALLOCATABLE, DIMENSION(:)       :: varktmp
 
-    REAL, DIMENSION(nbp_lon,nbp_lat,12)   :: psurf_glo2D   ! Surface pression for 12 months on dynamics global grid
+    REAL,  ALLOCATABLE                    :: psurf_glo2D(:,:,:)   ! Surface pression for 12 months on dynamics global grid
     REAL, DIMENSION(klon_glo,12)          :: psurf_glo1D   ! -"- on physical global grid
-    REAL, DIMENSION(nbp_lon,nbp_lat,12)   :: load_glo2D    ! Load for 12 months on dynamics global grid
+    REAL,  ALLOCATABLE                    :: load_glo2D(:,:,:)    ! Load for 12 months on dynamics global grid
     REAL, DIMENSION(klon_glo,12)          :: load_glo1D    ! -"- on physical global grid
-    REAL, DIMENSION(nbp_lon,nbp_lat)      :: vartmp
-    REAL, DIMENSION(nbp_lon)              :: lon_src              ! longitudes in file
-    REAL, DIMENSION(nbp_lat)              :: lat_src, lat_src_inv ! latitudes in file
+    REAL, ALLOCATABLE, DIMENSION(:,:)     :: vartmp
+    REAL, ALLOCATABLE,DIMENSION(:)        :: lon_src              ! longitudes in file
+    REAL, ALLOCATABLE,DIMENSION(:)        :: lat_src, lat_src_inv ! latitudes in file
     LOGICAL                               :: new_file             ! true if new file format detected
     LOGICAL                               :: invert_lat           ! true if the field has to be inverted for latitudes
-
-
+    INTEGER                               :: nbp_lon, nbp_lat
+    LOGICAL,SAVE                          :: first=.TRUE.
+!$OMP THREADPRIVATE(first)
+    
+    IF (grid_type==unstructured) THEN
+      nbp_lon=nbp_lon_src
+      nbp_lat=nbp_lat_src
+    ELSE
+      nbp_lon=nbp_lon_
+      nbp_lat=nbp_lat_
+    ENDIF
+    
+    IF (is_mpi_root) THEN
+    
+      ALLOCATE(psurf_glo2D(nbp_lon,nbp_lat,12))
+      ALLOCATE(load_glo2D(nbp_lon,nbp_lat,12))
+      ALLOCATE(vartmp(nbp_lon,nbp_lat))
+      ALLOCATE(lon_src(nbp_lon))
+      ALLOCATE(lat_src(nbp_lat))
+      ALLOCATE(lat_src_inv(nbp_lat))
+    ELSE
+      ALLOCATE(varyear(0,0,0,0))
+      ALLOCATE(psurf_glo2D(0,0,0))
+      ALLOCATE(load_glo2D(0,0,0))
+    ENDIF
+            
     ! Deallocate pointers
     IF (ASSOCIATED(pt_ap)) DEALLOCATE(pt_ap)
@@ -245,41 +350,44 @@
        CALL check_err( nf90_open(TRIM(fname), NF90_NOWRITE, ncid), "pb open "//trim(fname) )
 
+
+       IF (grid_type/=unstructured) THEN
+
 ! Test for equal longitudes and latitudes in file and model
 !****************************************************************************************
        ! Read and test longitudes
-       CALL check_err( nf90_inq_varid(ncid, 'lon', varid),"pb inq lon" )
-       CALL check_err( nf90_get_var(ncid, varid, lon_src(:)),"pb get lon" )
+         CALL check_err( nf90_inq_varid(ncid, 'lon', varid),"pb inq lon" )
+         CALL check_err( nf90_get_var(ncid, varid, lon_src(:)),"pb get lon" )
        
-       IF (maxval(ABS(lon_src - io_lon)) > 0.001) THEN
-          WRITE(lunout,*) 'Problem in longitudes read from file : ',TRIM(fname)
-          WRITE(lunout,*) 'longitudes in file ', TRIM(fname),' : ', lon_src
-          WRITE(lunout,*) 'longitudes in model :', io_lon
+         IF (maxval(ABS(lon_src - io_lon)) > 0.001) THEN
+            WRITE(lunout,*) 'Problem in longitudes read from file : ',TRIM(fname)
+            WRITE(lunout,*) 'longitudes in file ', TRIM(fname),' : ', lon_src
+            WRITE(lunout,*) 'longitudes in model :', io_lon
           
-          CALL abort_physic('get_aero_fromfile', 'longitudes are not the same in file and model',1)
-       END IF
-
-       ! Read and test latitudes
-       CALL check_err( nf90_inq_varid(ncid, 'lat', varid),"pb inq lat" )
-       CALL check_err( nf90_get_var(ncid, varid, lat_src(:)),"pb get lat" )
-
-       ! Invert source latitudes
-       DO j = 1, nbp_lat
-          lat_src_inv(j) = lat_src(nbp_lat +1 -j)
-       END DO
-
-       IF (maxval(ABS(lat_src - io_lat)) < 0.001) THEN
-          ! Latitudes are the same
-          invert_lat=.FALSE.
-       ELSE IF (maxval(ABS(lat_src_inv - io_lat)) < 0.001) THEN
-          ! Inverted source latitudes correspond to model latitudes
-          WRITE(lunout,*) 'latitudes will be inverted for file : ',TRIM(fname)
-          invert_lat=.TRUE.
-       ELSE
-          WRITE(lunout,*) 'Problem in latitudes read from file : ',TRIM(fname)
-          WRITE(lunout,*) 'latitudes in file ', TRIM(fname),' : ', lat_src      
-          WRITE(lunout,*) 'latitudes in model :', io_lat
-          CALL abort_physic('get_aero_fromfile', 'latitudes do not correspond between file and model',1)
-       END IF
-
+            CALL abort_physic('get_aero_fromfile', 'longitudes are not the same in file and model',1)
+         END IF
+
+         ! Read and test latitudes
+         CALL check_err( nf90_inq_varid(ncid, 'lat', varid),"pb inq lat" )
+         CALL check_err( nf90_get_var(ncid, varid, lat_src(:)),"pb get lat" )
+
+         ! Invert source latitudes
+         DO j = 1, nbp_lat
+            lat_src_inv(j) = lat_src(nbp_lat +1 -j)
+         END DO
+
+         IF (maxval(ABS(lat_src - io_lat)) < 0.001) THEN
+            ! Latitudes are the same
+            invert_lat=.FALSE.
+         ELSE IF (maxval(ABS(lat_src_inv - io_lat)) < 0.001) THEN
+            ! Inverted source latitudes correspond to model latitudes
+            WRITE(lunout,*) 'latitudes will be inverted for file : ',TRIM(fname)
+            invert_lat=.TRUE.
+         ELSE
+            WRITE(lunout,*) 'Problem in latitudes read from file : ',TRIM(fname)
+            WRITE(lunout,*) 'latitudes in file ', TRIM(fname),' : ', lat_src      
+            WRITE(lunout,*) 'latitudes in model :', io_lat
+            CALL abort_physic('get_aero_fromfile', 'latitudes do not correspond between file and model',1)
+         END IF
+       ENDIF
 
 ! 2) Check if old or new file is avalabale.
@@ -487,60 +595,64 @@
        END IF
 
-!     - Invert latitudes if necessary
-       DO imth=1, 12
-          IF (invert_lat) THEN
-
-             ! Invert latitudes for the variable
-             varmth(:,:,:) = varyear(:,:,:,imth) ! use varmth temporarly
-             DO k=1,klev_src
-                DO j=1,nbp_lat
-                   DO i=1,nbp_lon
-                      varyear(i,j,k,imth) = varmth(i,nbp_lat+1-j,k)
-                   END DO
-                END DO
-             END DO
+
+       IF (grid_type/=unstructured) THEN
+  !     - Invert latitudes if necessary
+         DO imth=1, 12
+            IF (invert_lat) THEN
+
+               ! Invert latitudes for the variable
+               varmth(:,:,:) = varyear(:,:,:,imth) ! use varmth temporarly
+               DO k=1,klev_src
+                  DO j=1,nbp_lat
+                     DO i=1,nbp_lon
+                        varyear(i,j,k,imth) = varmth(i,nbp_lat+1-j,k)
+                     END DO
+                  END DO
+               END DO
              
-             ! Invert latitudes for surface pressure
-             vartmp(:,:) = psurf_glo2D(:,:,imth)
-             DO j=1,nbp_lat
-                DO i=1,nbp_lon
-                   psurf_glo2D(i,j,imth)= vartmp(i,nbp_lat+1-j)
-                END DO
-             END DO
+               ! Invert latitudes for surface pressure
+               vartmp(:,:) = psurf_glo2D(:,:,imth)
+               DO j=1,nbp_lat
+                  DO i=1,nbp_lon
+                     psurf_glo2D(i,j,imth)= vartmp(i,nbp_lat+1-j)
+                  END DO
+               END DO
              
-             ! Invert latitudes for the load
-             vartmp(:,:) = load_glo2D(:,:,imth)
-             DO j=1,nbp_lat
-                DO i=1,nbp_lon
-                   load_glo2D(i,j,imth)= vartmp(i,nbp_lat+1-j)
-                END DO
-             END DO
-          END IF ! invert_lat
+               ! Invert latitudes for the load
+               vartmp(:,:) = load_glo2D(:,:,imth)
+               DO j=1,nbp_lat
+                  DO i=1,nbp_lon
+                     load_glo2D(i,j,imth)= vartmp(i,nbp_lat+1-j)
+                  END DO
+               END DO
+            END IF ! invert_lat
              
-          ! Do zonal mead at poles and distribut at whole first and last latitude
-          DO k=1, klev_src
-             npole=0.  ! North pole, j=1
-             spole=0.  ! South pole, j=nbp_lat        
-             DO i=1,nbp_lon
-                npole = npole + varyear(i,1,k,imth)
-                spole = spole + varyear(i,nbp_lat,k,imth)
-             END DO
-             npole = npole/REAL(nbp_lon)
-             spole = spole/REAL(nbp_lon)
-             varyear(:,1,    k,imth) = npole
-             varyear(:,nbp_lat,k,imth) = spole
-          END DO
-       END DO ! imth
+            ! Do zonal mead at poles and distribut at whole first and last latitude
+            DO k=1, klev_src
+               npole=0.  ! North pole, j=1
+               spole=0.  ! South pole, j=nbp_lat        
+               DO i=1,nbp_lon
+                  npole = npole + varyear(i,1,k,imth)
+                  spole = spole + varyear(i,nbp_lat,k,imth)
+               END DO
+               npole = npole/REAL(nbp_lon)
+               spole = spole/REAL(nbp_lon)
+               varyear(:,1,    k,imth) = npole
+               varyear(:,nbp_lat,k,imth) = spole
+            END DO
+         END DO ! imth
        
-       ALLOCATE(varyear_glo1D(klon_glo, klev_src, 12), stat=ierr)
-       IF (ierr /= 0) CALL abort_physic('get_aero_fromfile', 'pb in allocation 3',1)
+         ALLOCATE(varyear_glo1D(klon_glo, klev_src, 12), stat=ierr)
+         IF (ierr /= 0) CALL abort_physic('get_aero_fromfile', 'pb in allocation 3',1)
        
-       ! Transform from 2D to 1D field
-       CALL grid2Dto1D_glo(varyear,varyear_glo1D)
-       CALL grid2Dto1D_glo(psurf_glo2D,psurf_glo1D)
-       CALL grid2Dto1D_glo(load_glo2D,load_glo1D)
-
+         ! Transform from 2D to 1D field
+         CALL grid2Dto1D_glo(varyear,varyear_glo1D)
+         CALL grid2Dto1D_glo(psurf_glo2D,psurf_glo1D)
+         CALL grid2Dto1D_glo(load_glo2D,load_glo1D)
+      
+      ENDIF
+      
     ELSE
-      ALLOCATE(varyear_glo1D(0,0,0))        
+        ALLOCATE(varyear_glo1D(0,0,0))        
     END IF ! is_mpi_root .AND. is_omp_root
 
@@ -566,11 +678,29 @@
     IF (ASSOCIATED(pt_year)) DEALLOCATE(pt_year)
     ALLOCATE(pt_year(klon, klev_src, 12), stat=ierr)
+    ALLOCATE(pt_year_mpi(klon_mpi, klev_src, 12), stat=ierr)
     IF (ierr /= 0) CALL abort_physic('get_aero_fromfile', 'pb in allocation 5',1)
 
-    ! Scatter global field to local domain at local process
-    CALL scatter(varyear_glo1D, pt_year)
-    CALL scatter(psurf_glo1D, psurf_out)
-    CALL scatter(load_glo1D,  load_out)
-
+    IF (grid_type==unstructured) THEN
+      IF (is_omp_master) THEN
+        CALL xios_send_field(TRIM(varname)//"_in",varyear)
+        CALL xios_recv_field(TRIM(varname)//"_out",pt_year_mpi)
+        CALL xios_send_field("load_"//TRIM(varname)//"_in",load_glo2D)
+        CALL xios_recv_field("load_"//TRIM(varname)//"_out",load_out_mpi)
+        IF (first) THEN
+          ALLOCATE(psurf_interp(klon_mpi,12))
+          CALL xios_send_field("psurf_aerosol_in",psurf_glo2D)
+          CALL xios_recv_field("psurf_aerosol_out",psurf_interp)
+        ENDIF
+      ENDIF
+      CALL scatter_omp(pt_year_mpi,pt_year)
+      CALL scatter_omp(load_out_mpi,load_out)
+      CALL scatter_omp(psurf_interp,psurf_out)
+      first=.FALSE.
+    ELSE
+      ! Scatter global field to local domain at local process
+      CALL scatter(varyear_glo1D, pt_year)
+      CALL scatter(psurf_glo1D, psurf_out)
+      CALL scatter(load_glo1D,  load_out)
+    ENDIF
 ! 7) Test for negative values
 !****************************************************************************************
Index: /LMDZ6/trunk/libf/phylmd/readaerosolstrato.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/readaerosolstrato.F90	(revision 3434)
+++ /LMDZ6/trunk/libf/phylmd/readaerosolstrato.F90	(revision 3435)
@@ -7,5 +7,5 @@
     USE phys_cal_mod, ONLY : mth_cur
     USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, klon_glo, &
-                                 grid2dto1d_glo
+                                 grid2dto1d_glo, grid_type, unstructured
     USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
     USE mod_phys_lmdz_omp_data, ONLY :  is_omp_root
@@ -15,4 +15,5 @@
     USE aero_mod
     USE dimphy
+    USE xios
 
     implicit none
@@ -43,4 +44,5 @@
     real, allocatable:: tauaerstrat_mois(:, :, :)
     real, allocatable:: tauaerstrat_mois_glo(:, :)
+    real, allocatable:: tau_aer_strat_mpi(:, :)
 
 ! For NetCDF:
@@ -87,18 +89,22 @@
     n_lat = size(latitude)
     print *, 'LAT aerosol strato=', n_lat, latitude
-    IF (n_lat.NE.nbp_lat) THEN 
-       print *,'Le nombre de lat n est pas egal a nbp_lat'
-       STOP
-    ENDIF
-
+    IF (grid_type/=unstructured) THEN
+      IF (n_lat.NE.nbp_lat) THEN 
+         print *,'Le nombre de lat n est pas egal a nbp_lat'
+         STOP
+      ENDIF
+    ENDIF
+    
     CALL nf95_inq_varid(ncid_in, "LON", varid)
     CALL nf95_gw_var(ncid_in, varid, longitude)
     n_lon = size(longitude)
-    print *, 'LON aerosol strato=', n_lon, longitude
-    IF (n_lon.NE.nbp_lon) THEN 
-       print *,'Le nombre de lon n est pas egal a nbp_lon'
-       STOP
-    ENDIF
-
+    IF (grid_type/=unstructured) THEN
+      print *, 'LON aerosol strato=', n_lon, longitude
+      IF (n_lon.NE.nbp_lon) THEN 
+         print *,'Le nombre de lon n est pas egal a nbp_lon'
+         STOP
+      ENDIF
+    ENDIF
+    
     CALL nf95_inq_varid(ncid_in, "TIME", varid)
     CALL nf95_gw_var(ncid_in, varid, time)
@@ -130,10 +136,23 @@
     CALL grid2dTo1d_glo(tauaerstrat_mois,tauaerstrat_mois_glo)
 
+    ELSE
+      ALLOCATE(tauaerstrat_mois(0,0,0))
     ENDIF !--is_mpi_root and is_omp_root
 
 !$OMP BARRIER
 
+    IF (grid_type==unstructured) THEN
+      IF (is_omp_master) THEN
+        CALL xios_send_field("taustrat_in",tauaerstrat_mois)
+        ALLOCATE(tau_aer_strat_mpi(klon_mpi, klev))
+        CALL xios_recv_field("taustrat_out",tau_aer_strat_mpi)
+      ELSE
+        ALLOCATE(tau_aer_strat_mpi(0,0))
+      ENDIF
+      CALL scatter_omp(tau_aer_strat_mpi,tau_aer_strat)
+    ELSE  
 !--scatter on all proc
-    CALL scatter(tauaerstrat_mois_glo,tau_aer_strat)
+      CALL scatter(tauaerstrat_mois_glo,tau_aer_strat)
+    ENDIF
 
 !--keep memory of previous month
Index: /LMDZ6/trunk/libf/phylmd/readaerosolstrato_m.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/readaerosolstrato_m.F90	(revision 3435)
+++ /LMDZ6/trunk/libf/phylmd/readaerosolstrato_m.F90	(revision 3435)
@@ -0,0 +1,135 @@
+MODULE readaerosolstrato_m
+
+
+CONTAINS
+
+  SUBROUTINE init_readaerosolstrato(flag_aerosol_strat)
+  USE mod_grid_phy_lmdz, ONLY: grid_type, unstructured
+  IMPLICIT NONE
+  INTEGER,INTENT(IN) :: flag_aerosol_strat
+    
+    IF (grid_type==unstructured)  THEN 
+   
+      IF (flag_aerosol_strat == 1) THEN
+        CALL init_readaerosolstrato1
+      ELSE IF (flag_aerosol_strat == 2) THEN
+        CALL init_readaerosolstrato2
+      ENDIF
+  
+    ENDIF
+  
+  END SUBROUTINE init_readaerosolstrato
+  
+
+
+  SUBROUTINE init_readaerosolstrato1
+  USE netcdf
+  USE netcdf95, ONLY: nf95_close, nf95_gw_var, nf95_inq_dimid, & 
+                      nf95_inq_varid, nf95_open
+  USE mod_phys_lmdz_para
+  USE xios
+  USE YOERAD, ONLY : NLW
+  IMPLICIT NONE
+  REAL, POINTER:: latitude(:)
+  REAL, POINTER:: longitude(:)
+  INTEGER :: nlat, nlon
+  REAL    :: null_array(0)
+  INTEGER :: ncid_in, varid
+  
+    IF (is_omp_master) THEN  
+      IF (is_mpi_root) THEN
+        CALL nf95_open("taustrat.nc", nf90_nowrite, ncid_in)
+        CALL nf95_inq_varid(ncid_in, "LAT", varid)
+        CALL nf95_gw_var(ncid_in, varid, latitude)
+        CALL nf95_inq_varid(ncid_in, "LON", varid)
+        CALL nf95_gw_var(ncid_in, varid, longitude)
+        CALL nf95_close(ncid_in)
+        nlat=size(latitude)
+        nlon=size(longitude)
+      ENDIF
+      CALL bcast_mpi(nlat)
+      CALL bcast_mpi(nlon)
+
+      IF (is_mpi_root) THEN
+        CALL xios_set_domain_attr("domain_taustrat",nj_glo=nlat, nj=nlat, jbegin=0, latvalue_1d=latitude)
+        CALL xios_set_domain_attr("domain_taustrat",ni_glo=nlon, ni=nlon, ibegin=0, lonvalue_1d = longitude)
+       ELSE
+        CALL xios_set_domain_attr("domain_taustrat",nj_glo=nlat, nj=0, jbegin=0, latvalue_1d=null_array )
+        CALL xios_set_domain_attr("domain_taustrat",ni_glo=nlon, ni=0, ibegin=0, lonvalue_1d=null_array)
+      ENDIF    
+  
+      CALL xios_set_fieldgroup_attr("aerosol_strato1",enabled=.TRUE.)
+    ENDIF
+    
+  END SUBROUTINE init_readaerosolstrato1
+  
+  SUBROUTINE init_readaerosolstrato2
+  USE netcdf
+  USE netcdf95, ONLY: nf95_close, nf95_gw_var, nf95_inq_dimid, & 
+                      nf95_inq_varid, nf95_open
+  USE mod_phys_lmdz_para
+  USE xios
+  USE YOERAD, ONLY : NLW
+  IMPLICIT NONE
+  REAL, POINTER:: latitude(:)
+  REAL, POINTER:: wav(:)
+  INTEGER :: nlat,n_wav
+  REAL    :: null_array(0)
+  INTEGER :: ncid_in, varid
+
+    IF (is_omp_master) THEN    
+      IF (is_mpi_root) THEN
+        CALL nf95_open("tauswstrat.2D.nc", nf90_nowrite, ncid_in)
+        CALL nf95_inq_varid(ncid_in, "LAT", varid)
+        CALL nf95_gw_var(ncid_in, varid, latitude)
+        CALL nf95_inq_varid(ncid_in, "WAV", varid)
+        CALL nf95_gw_var(ncid_in, varid, wav)
+        CALL nf95_close(ncid_in)
+        nlat=size(latitude)
+        n_wav = size(wav)
+      ENDIF
+      CALL bcast_mpi(nlat)
+      CALL bcast_mpi(n_wav)
+
+      IF (is_mpi_root) THEN
+        CALL xios_set_domain_attr("domain_tauswstrat",nj_glo=nlat, nj=nlat, jbegin=0, latvalue_1d=latitude)
+        CALL xios_set_domain_attr("domain_tauswstrat",ni_glo=8, ni=8, ibegin=0, lonvalue_1d = (/ 0.,45.,90.,135.,180.,225.,270., 315. /))
+        DEALLOCATE(latitude)
+      ELSE
+        CALL xios_set_domain_attr("domain_tauswstrat",nj_glo=nlat, nj=0, jbegin=0, latvalue_1d=null_array )
+        CALL xios_set_domain_attr("domain_tauswstrat",ni_glo=8, ni=0, ibegin=0, lonvalue_1d=null_array)
+      ENDIF    
+      CALL  xios_set_axis_attr("nsw", n_glo=n_wav)
+    
+      IF (is_mpi_root) THEN
+        CALL nf95_open("taulwstrat.2D.nc", nf90_nowrite, ncid_in)
+        CALL nf95_inq_varid(ncid_in, "LAT", varid)
+        CALL nf95_gw_var(ncid_in, varid, latitude)
+        CALL nf95_inq_varid(ncid_in, "WAV", varid)
+        CALL nf95_gw_var(ncid_in, varid, wav)
+        CALL nf95_close(ncid_in)
+        nlat=size(latitude)
+        n_wav = size(wav)
+      ENDIF
+      CALL bcast_mpi(nlat)
+      CALL bcast_mpi(n_wav)
+
+      IF (is_mpi_root) THEN
+        CALL xios_set_domain_attr("domain_taulwstrat",nj_glo=nlat, nj=nlat, jbegin=0, latvalue_1d=latitude)
+        CALL xios_set_domain_attr("domain_taulwstrat",ni_glo=8, ni=8, ibegin=0, lonvalue_1d = (/ 0.,45.,90.,135.,180.,225.,270., 315. /))
+        DEALLOCATE(latitude)
+      ELSE
+        CALL xios_set_domain_attr("domain_taulwstrat",nj_glo=nlat, nj=0, jbegin=0, latvalue_1d=null_array )
+        CALL xios_set_domain_attr("domain_taulwstrat",ni_glo=8, ni=0, ibegin=0, lonvalue_1d=null_array)
+      ENDIF    
+    
+      CALL  xios_set_axis_attr("nlw", n_glo=n_wav)
+      CALL xios_set_fieldgroup_attr("aerosol_strato2",enabled=.TRUE.)
+
+    ENDIF
+    
+  END SUBROUTINE init_readaerosolstrato2
+  
+
+END MODULE readaerosolstrato_m
+
Index: /LMDZ6/trunk/libf/phylmd/regr_horiz_time_climoz_m.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/regr_horiz_time_climoz_m.F90	(revision 3434)
+++ /LMDZ6/trunk/libf/phylmd/regr_horiz_time_climoz_m.F90	(revision 3435)
@@ -2,5 +2,5 @@
 
   USE interpolation,     ONLY: locate
-  USE mod_grid_phy_lmdz, ONLY: nlon_ou => nbp_lon, nlat_ou => nbp_lat
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, grid_type, unstructured
   USE nrtype,            ONLY: pi
   USE netcdf,   ONLY: NF90_CLOBBER, NF90_FLOAT,     NF90_GET_VAR, NF90_OPEN,   &
@@ -11,4 +11,5 @@
           NF95_CLOSE, NF95_ENDDEF,  NF95_PUT_ATT,   NF95_PUT_VAR, NF95_COPY_ATT
   USE print_control_mod, ONLY: lunout
+  USE dimphy
   IMPLICIT NONE
   PRIVATE
@@ -16,4 +17,10 @@
   REAL, PARAMETER :: deg2rad=pi/180.
   CHARACTER(LEN=13), PARAMETER :: vars_in(2)=['tro3         ','tro3_daylight']
+
+  INTEGER :: nlat_ou, nlon_ou
+  REAL, ALLOCATABLE :: latitude_glo(:)
+!$OMP THREADPRIVATE(latitude_glo)
+  INTEGER, ALLOCATABLE :: ind_cell_glo_glo(:)
+!$OMP THREADPRIVATE(ind_cell_glo_glo)
 
 CONTAINS
@@ -52,5 +59,6 @@
   USE assert_m,           ONLY: assert
   USE cal_tools_m,        ONLY: year_len, mid_month
-  USE control_mod,        ONLY: anneeref
+!!  USE control_mod,        ONLY: anneeref
+  USE time_phylmdz_mod,   ONLY: annee_ref
   USE ioipsl,             ONLY: ioget_year_len, ioget_calendar
   USE regr_conserv_m,     ONLY: regr_conserv
@@ -58,4 +66,9 @@
   USE regular_lonlat_mod, ONLY: boundslon_reg, boundslat_reg, south, west, east
   USE slopes_m,           ONLY: slopes
+  USE xios
+  USE mod_phys_lmdz_para, ONLY: is_mpi_root, is_master, is_omp_master, gather, gather_mpi, bcast_mpi, klon_mpi
+  USE geometry_mod, ONLY : latitude_deg, ind_cell_glo
+  USE mod_grid_phy_lmdz, ONLY: klon_glo
+
 !-------------------------------------------------------------------------------
 ! Arguments:
@@ -83,5 +96,7 @@
   CHARACTER(LEN=20) :: cal_in              ! Calendar
   REAL, ALLOCATABLE :: o3_in3(:,:,:,:,:)   ! Ozone climatologies
+  REAL, ALLOCATABLE :: o3_in3bis(:,:,:,:,:)   ! Ozone climatologies
   REAL, ALLOCATABLE :: o3_in2  (:,:,:,:)   ! Ozone climatologies
+  REAL, ALLOCATABLE :: o3_in2bis(:,:,:,:,:)   ! Ozone climatologies
   ! last index: 1 for the day-night average, 2 for the daylight field.
   REAL :: NaN
@@ -91,6 +106,9 @@
   REAL, ALLOCATABLE :: o3_regr_lonlat(:,:,:,:,:) ! (nlon_ou,nlat_ou,:,0:13   ,:)
   REAL, ALLOCATABLE :: o3_out3       (:,:,:,:,:) ! (nlon_ou,nlat_ou,:,ntim_ou,:)
+  REAL, ALLOCATABLE :: o3_out3_glo   (:,:,:,:) !   (nbp_lat,:,ntim_ou,:)
   REAL, ALLOCATABLE :: o3_regr_lat     (:,:,:,:) !         (nlat_in,:,0:13   ,:)
   REAL, ALLOCATABLE :: o3_out2         (:,:,:,:) !         (nlat_ou,:,ntim_ou,:)
+  REAL, ALLOCATABLE :: o3_out2_glo     (:,:,:,:) !         (nbp_lat,:,ntim_ou,:)
+  REAL, ALLOCATABLE :: o3_out          (:,:,:,:) !         (nbp_lat,:,ntim_ou,:)
 ! Dimension number  | Interval                | Contains  | For variables:
 !   1 (longitude)   | [rlonu(i-1), rlonu(i)]  | rlonv(i)  | all
